//
//  Iterador.h
//  Class Template "Iterador"
//
//  Created by Carlos Santos
//

#ifndef Iterador_h
#define Iterador_h

#pragma once
#include <stdlib.h>
#include "NoDuplo.h"

template <class T>
class Iterador {
private:
    // Apontador para o nó actual do iterador
    NoDuplo<T> *noActual;
    
public:
    // Construtor do iterador que deverá receber um nó
    // Poderá receber a cabeça ou a cauda da lista para iterar os nós todos
    Iterador(NoDuplo<T> *no = NULL) : noActual(no) {}
    ~Iterador() {
        if (noActual==NULL) {
            noActual = NULL;
        }
    }
    // Devolve o próximo nó até chegar ao fim (NULL)
    NoDuplo<T> *noSeguinte() {
        if (noActual==NULL) {
            return NULL;
        }
        noActual = noActual->seguinte;
        return noActual;
    }
    // Devolve o nó anterior até chegar ao início (NULL)
    NoDuplo<T> *noAnterior() {
        if (noActual==NULL) {
            return NULL;
        }
        noActual = noActual->anterior;
        return noActual;
    }
    
};

#endif
