//
//  lista_inteiros.cpp
//  Define uma lista de inteiros ordenada por ordem decrescente
//  Este exemplo usa os seguintes métodos da class ListaDupla:
//  - vazia
//  - inserePrimeiro
//  - insereUltimo
//  - insereDepoisDe
//  - remove
//  - obtemIteradorCabeca
//  - obremIteradorCauda
//
//  Created by Carlos Santos
//

#include "lista_inteiros.h"

using namespace std;

void lista_inteiros() {
    
    ListaDupla<int> *listaInteiros = new ListaDupla<int>();
    char menu = ' ';
    char valor[6];
    int v;
    
    while (menu!='0') {
        
        cout << endl << "=== Lista de inteiros ===" << endl;
        cout << "1 - Inserir numero" << endl;
        cout << "2 - Remover numero" << endl;
        cout << "3 - Listar numeros" << endl;
        cout << "0 - Sair da lista de inteiros" << endl;
        if (!(cin >> menu)) {
            // Se foram introduzidos caracteres incorrectos, limpa o estado de erro e ignora os caracteres
            cin.clear();
            cin.ignore(10000, '\n');
            menu = ' ';
        }
        
        switch (menu) {
            case '0':
                break;
            case '1':
                cout << "Introduza um inteiro: ";
                if (!(cin >> valor)) {
                    // Se foram introduzidos caracteres incorrectos, limpa o estado de erro e ignora os caracteres
                    cin.clear();
                    cin.ignore(10000, '\n');
                    cout << "Erro na introdução do valor" << endl;
                    break;
                }
                v = atoi(valor);
                
                // Verifica se a lista está vazia
                if (listaInteiros->vazia()) {
                    // Se a lista estiver vazia, insere um "primeiro" elemento
                    listaInteiros->insereUltimo(v);
                }
                else {
                    // Obtem um iterador a partir da cauda
                    Iterador<int> *i = listaInteiros->obtemIteradorCauda();
                    NoDuplo<int> *procura;
                    // Procura, a partir da cauda, o nó com o valor maior do que o que queremos inserir
                    while ((procura=i->noAnterior())!=NULL) {
                        int p = procura->elemento;
                        if (p>v) {
                            // Se encontrou um valor maior, interrompe o ciclo
                            break;
                        }
                    }

                    if (procura==NULL) {
                        // Se o valor não foi encontrado, insere o valor à cabeça
                        listaInteiros->inserePrimeiro(v);
                    }
                    else {
                        // Se encontrármos, insere o novo valor depois da posição encontrada
                        listaInteiros->insereDepoisDe(procura, v);
                    }
                    // Liberta o iterador
                    delete i;
                }
                break;
            case '2': {
                cout << "Introduza o inteiro a remover: ";
                cin >> valor;
                v = atoi(valor);
                
                // Obtem o iterador a partir da cabeça
                Iterador<int> *i = listaInteiros->obtemIteradorCabeca();
                NoDuplo<int> *procura;
                // Procura o nó com o valor a remover
                while ((procura=i->noSeguinte())!=NULL) {
                    if (procura->elemento==v) {
                        // Se o encontrar, interrompe o ciclo
                        break;
                    }
                }
                
                if (procura==NULL) {
                    // Se o valor não foi encontrado...
                    cout << "O valor não foi encontrado ou a lista está vazia" << endl;
                }
                else {
                    // Se o encontrou, tenta removê-lo da lista
                    if (listaInteiros->remove(procura)) {
                        cout << "Valor removido com sucesso" << endl;
                    }
                    else {
                        cout << "Erro ao remover o valor" << endl;
                    }
                }
                delete i;
                break;
            }
            case '3':
                if (listaInteiros->vazia()) {
                    cout << "A lista está vazia" << endl;
                }
                else {
                    cout << endl << "Inteiros por ordem decrescente" << endl;
                    // Obtem o iterador para listar os nós com os números inteiros a partir da cabeça
                    Iterador<int> *i = listaInteiros->obtemIteradorCabeca();
                    NoDuplo<int> *listar;
                    // Lista todos os nós através do iterador
                    while ((listar=i->noSeguinte())!=NULL) {
                        cout << listar->elemento << endl;
                    }
                    delete i;
                }
                break;
            default:
                cout << "Opção inválida" << endl;
                break;
        }
    }
    
    // Liberta a lista da memória
    delete listaInteiros;
    
}